#include "fbgfx.bi"
using fb
randomize timer*1000
#include "O-Pat-Kono.bi"
'declare function scan_for_move(player as uinteger, b as matrix_t ptr) as matrix_t ptr
'declare function scan_for_opponent_block(player as uinteger, b as matrix_t ptr) as matrix_t ptr
'declare function scan_for_friend_block(player as uinteger, b as matrix_t ptr) as matrix_t ptr
'declare function scan_for_win_positions(player as uinteger, b as matrix_t ptr) as matrix_t ptr

declare sub draw_char(char as ubyte,x as uinteger,y as uinteger,col as ubyte,scale as uinteger=1)
declare sub draw_screen(scale as uinteger=1)
declare sub draw_to_screen(x_pos as uinteger,y_pos as uinteger,x_size as uinteger,y_size as uinteger,chars as ubyte ptr,colors as ubyte ptr,scale as uinteger=1)

declare sub create_color_cycles()

declare sub fade_out(scale as uinteger=1)
declare sub fade_in(scale as uinteger=1)

declare sub print_menue_color_cycle(scale as uinteger=1)
declare sub print_credits_screen_color_cycle(scale as uinteger=1)
declare sub print_help_screen_color_cycle(scale as uinteger=1)
declare sub print_game_cursor_color_cycle(scale as uinteger=1)
declare sub print_players(scale as uinteger=1)

declare sub print_game_mode_str(scale as uinteger=1)
declare sub print_sound_mode_str(scale as uinteger=1)

declare sub check_is_over_goblin(x as byte,y as byte)
declare sub check_is_valid(x as byte, y as byte)
declare sub check_for_win()

declare sub update_player_pos()

declare sub reset_play_ground()

declare sub ki_thinking(player as ubyte)


reset_play_ground()

dim as string in
dim scale as uinteger=3.0
screenres 8*40*scale,8*25*scale,32,GFX_ALPHA_PRIMITIVES
'SoundSet 44100,2,16

while TRUE
	dim t as ubyte = rnd*255
	in=inkey
	skipper_count+=1
	check_is_over_goblin(cursor_x_pos(current_player),cursor_y_pos(current_player))
	check_is_valid(cursor_x_pos(current_player),cursor_y_pos(current_player))

	if (skipper_count mod 1)=0 then
		credits_counter+=1
		create_color_cycles()
	endif

	if animate_flag=&hff then
		if (skipper_count mod 7)=0 then
			animate_players+=1
			animate_players=iif(animate_players>3,0,animate_players)
			animate_brett=(animate_players and 1)
			if (animate_players=2) or (animate_players=0) then
				animate_flag=0
				current_player+=1
				current_player=(current_player and 1)
			EndIf
		endif
	EndIf


	if (credits_counter=&hff) and ((current_game_screen_nr=0) or (current_game_screen_nr=6)) then
		credits_counter=0
		need_redraw=1
		'fade_out(scale)
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr+=6
		current_game_screen_nr=iif(current_game_screen_nr>6,0,current_game_screen_nr)
		'fade_in(scale)
	EndIf
	if need_redraw=1 then
		fade_out(scale)
		fade_in(scale)
	else
		screenlock
		line(0,0)-(8*40*scale,8*25*scale),0,BF
		draw_screen(scale)
		if current_game_screen_nr=0 then
			print_menue_color_cycle(scale)
			print_game_mode_str(scale)
			print_sound_mode_str(scale)
		endif
		if current_game_screen_nr=1 then
			if new_game=255 then
				reset_play_ground()
				current_player=(rnd*255) and 1
				animate_players=current_player*2
			EndIf
			if is_in_give_up=&hff then
				draw_to_screen(12,6,15,11,@give_up_chars(0),@give_up_color(0),scale)
				draw_char(81,24-yes_no*10,12,game_cursor_selected_goblin(0),scale)
				draw_char(209,19,11,game_cursor_color_cycle(0),scale)
			else
				dim as ubyte cha(0 to 12*15)={0}
				dim as ubyte col(0 to 12*15)={0}
				draw_to_screen(12,6,15,11,@cha(0),@col(0),scale)
				draw_to_screen(14,7,11,10,@brett_chars(0,0),@brett_colors(0,0),scale)
				print_players(scale)
				if animate_flag=&h00 then
					print_game_cursor_color_cycle(scale)
					crystal_animator+=1
					draw_char(77,18,4,current_player_color_cycle(current_player,0),scale)
					draw_char(206,19,4,current_player_color_cycle(current_player,0),scale)
					draw_char(78,20,4,current_player_color_cycle(current_player,0),scale)
					if (game_mode=1) and (current_player=1) then 
						ki_thinking(current_player)
					endif
					if (game_mode=2)then 
						ki_thinking(current_player)
					endif
					
				endif
			endif
		endif
		if (current_game_screen_nr>1) and (current_game_screen_nr<5) then
			print_help_screen_color_cycle(scale)
			if current_game_screen_nr=3 then
				draw_to_screen(14,7,11,10,@brett_chars(0,0),@brett_colors(0,0),scale)
				print_players(scale)
				draw_to_screen(29,14,5,4,@joy_chars(help_screen_joy_frame,0),@joy_colors(help_screen_joy_frame,0),scale)
				if animate_flag=&h00 then
					if skipper_count mod 7=0 then
						help_screen_animator+=1
						if help_screen_animator>10 then
							reset_play_ground()
							help_screen_animator=0
						EndIf
						help_screen_joy_frame=help_screen_1_joy_animation_frame(help_screen_animator)
						help_screen_animation_fn_ptr(help_screen_joy_frame)()
					EndIf
					print_game_cursor_color_cycle(scale)
				endif
			EndIf
			if current_game_screen_nr=4 then
				draw_to_screen(14,7,11,10,@brett_chars(animate_brett,0),@brett_colors(animate_brett,0),scale)
				print_players(scale)
				draw_to_screen(29,14,5,4,@joy_chars(help_screen_joy_frame,0),@joy_colors(help_screen_joy_frame,0),scale)
				if animate_flag=&h00 then
					if skipper_count mod 7=0 then
						help_screen_animator+=1
						if help_screen_animator>10 then
							reset_play_ground()
							help_screen_animator=0
						EndIf
						help_screen_joy_frame=help_screen_2_joy_animation_frame(help_screen_animator)
						help_screen_animation_fn_ptr(help_screen_joy_frame)()
					EndIf
					print_game_cursor_color_cycle(scale)
				endif
			EndIf
		endif
		if current_game_screen_nr=5 then

		endif
		if current_game_screen_nr=6 then
			print_credits_screen_color_cycle(scale)
		endif
		screenunlock
		screensync
		sleep 16
	endif


	if in="s" then
		if is_in_give_up=0 then
			joy_down_fn_addr(current_game_screen_nr)()
		endif
	EndIf
	if in="w" then
		if is_in_give_up=0 then
			joy_up_fn_addr(current_game_screen_nr)()
		endif
	EndIf
	if in="a" then
		if is_in_give_up=255 then
			give_up_left_fn()
		else
			joy_left_fn_addr(current_game_screen_nr)()
		EndIf
	EndIf
	if in="d" then
		if is_in_give_up=255 then
			give_up_right_fn()
		else
			joy_right_fn_addr(current_game_screen_nr)()
		endif
	EndIf
	if in=" " then
		if is_in_give_up=255 then
			give_up_fire_fn()
		else
			joy_fire_fn_addr(current_game_screen_nr)()
		endif
	EndIf
	if in=CHR(255) & CHR(59) then
		credits_counter=0
		sound_mode+=1
		sound_mode=sound_mode and 1
	EndIf
	if current_game_screen_nr=1 then
		if in=CHR(9) then
			credits_counter=0
			is_in_give_up=255
		EndIf
	else
		is_in_give_up=0
	endif
	if in=chr(255,107) then exit while



	sleep 16
wend
'--------------------------------------------------------------------------------------------------------------------------------------------------
sub return_from_sub()
End Sub
sub menu_joy_up_fn()
	credits_counter=0
	menu_cursor_select-=1
	menu_cursor_select=iif(menu_cursor_select<0,2,menu_cursor_select)
End Sub
sub menu_joy_down_fn()
	credits_counter=0
	menu_cursor_select+=1
	menu_cursor_select=iif(menu_cursor_select>2,0,menu_cursor_select)
End Sub
sub menu_joy_fire_fn()
	credits_counter=0
	select case menu_cursor_select
		case 0:
			game_mode+=1
			game_mode=iif(game_mode>2,0,game_mode)
		case 1:
			new_game=255
			need_redraw=1
			last_game_screen_nr=current_game_screen_nr
			current_game_screen_nr=1
		case 2:
			need_redraw=1
			last_game_screen_nr=current_game_screen_nr
			current_game_screen_nr=2
	end select
End Sub

sub game_joy_up_fn()
	cursor_y_pos(current_player)-=1
	cursor_y_pos(current_player)=iif(cursor_y_pos(current_player)<0,0,cursor_y_pos(current_player))
End Sub
sub game_joy_down_fn()
	cursor_y_pos(current_player)+=1
	cursor_y_pos(current_player)=iif(cursor_y_pos(current_player)>4,4,cursor_y_pos(current_player))

End Sub
sub game_joy_left_fn()
	cursor_x_pos(current_player)-=1
	cursor_x_pos(current_player)=iif(cursor_x_pos(current_player)<0,0,cursor_x_pos(current_player))

End Sub
sub game_joy_right_fn()
	cursor_x_pos(current_player)+=1
	cursor_x_pos(current_player)=iif(cursor_x_pos(current_player)>4,4,cursor_x_pos(current_player))

End Sub
sub game_joy_fire_fn()
	if is_over_goblin(current_player)<>255 then
		if selected_goblin(current_player)=is_over_goblin(current_player) then
			selected_goblin(current_player)=255
			ki_round=0
		else
			selected_goblin(current_player)=is_over_goblin(current_player)
			ki_round=1
		EndIf
	EndIf
	if (is_over_goblin(current_player)=255) and (selected_goblin(current_player)<>255) then
		'check_is_valid(cursor_x_pos(current_player),cursor_y_pos(current_player))
		if is_valid=0 then
			exit sub
		else
			is_over_goblin(0)=255
			is_over_goblin(1)=255
			update_player_pos()
			ki_last_gnome(current_player)=selected_goblin(current_player)
			ki_last_gnome_round(current_player)+=1
			selected_goblin(0)=255
			selected_goblin(1)=255
			check_for_win()
			animate_flag=&hff
			crystal_animator=0
			ki_round=0
		EndIf
	EndIf
End Sub

sub help_joy_left_fn()
	need_redraw=1
	if current_game_screen_nr=2 then
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr=0
		reset_play_ground()
	else
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr-=1
	endif
	if (current_game_screen_nr=3) or (current_game_screen_nr=4) then
		help_screen_animator=0
		reset_play_ground()
	endif
End Sub
sub help_joy_right_fn()
	need_redraw=1
	if current_game_screen_nr=4 then
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr=0
		reset_play_ground()
	else
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr+=1
	endif
	if (current_game_screen_nr=3) or (current_game_screen_nr=4) then
		help_screen_animator=0
		reset_play_ground()
	endif
End Sub

sub give_up_left_fn()
	yes_no-=1
	yes_no=yes_no and 1
End Sub
sub give_up_right_fn()
	yes_no+=1
	yes_no=yes_no and 1
End Sub
sub give_up_fire_fn()
	if yes_no=1 then
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr=5
		need_redraw=1
	else
		is_in_give_up=0
	endif
End Sub

sub wins_joy_fire_fn()
	last_game_screen_nr=current_game_screen_nr
	current_game_screen_nr=0
	need_redraw=1
End Sub

sub credits_joy_fire_fn()
	last_game_screen_nr=current_game_screen_nr
	current_game_screen_nr=0
	need_redraw=1
End Sub


sub fade_out(scale as uinteger=1)
	dim as ubyte ptr chars=screens_chars_addr(last_game_screen_nr)
	dim as ubyte ptr colors=screens_color_addr(last_game_screen_nr)
	for i as uinteger=lbound(current_screen_colors) to ubound(current_screen_colors)
		current_screen_colors(i)=colors[i]
	Next
	for i as uinteger=0 to 8
		screenlock
		line(0,0)-(8*40*scale,8*25*scale),0,BF
		for x as integer=0 to 40' step -1
			for y as integer=0 to 25' step -1
				dim col_pos as uinteger=y*20+(x\2)
				dim source_color_h as ubyte=current_screen_colors(col_pos) shr 4
				dim source_color_l as ubyte=current_screen_colors(col_pos) and &h0f
				dim target_color_h as ubyte=0
				dim target_color_l as ubyte=0
				dim fade_color as ubyte=(fade_table(target_color_h,source_color_h) shl 4) or (fade_table(target_color_l,source_color_l))

				dim col as ubyte=iif(x mod 2=0,fade_color shr 4,fade_color)
				draw_char(chars[y*40+x],x,y,col,scale)
				current_screen_colors(col_pos)=fade_color
			Next
		Next
		screenunlock
		screensync
		sleep 32
	next
End Sub
sub fade_in(scale as uinteger=1)
	dim as ubyte ptr chars=screens_chars_addr(current_game_screen_nr)
	dim as ubyte ptr colors=screens_color_addr(current_game_screen_nr)
	for i as uinteger=lbound(current_screen_colors) to ubound(current_screen_colors)
		current_screen_colors(i)=0
	Next
	for i as uinteger=0 to 8
		screenlock
		line(0,0)-(8*40*scale,8*25*scale),0,BF
		for x as integer=0 to 40' step -1
			for y as integer=0 to 25' step -1
				dim col_pos as uinteger=y*20+(x\2)
				dim source_color_h as ubyte=current_screen_colors(col_pos) shr 4
				dim source_color_l as ubyte=current_screen_colors(col_pos) and &h0f
				dim target_color_h as ubyte=colors[col_pos] shr 4
				dim target_color_l as ubyte=colors[col_pos] and &h0f
				dim fade_color as ubyte=(fade_table(target_color_h,source_color_h) shl 4) or (fade_table(target_color_l,source_color_l))

				dim col as ubyte=iif(x mod 2=0,fade_color shr 4,fade_color)
				draw_char(chars[y*40+x],x,y,col,scale)
				current_screen_colors(col_pos)=fade_color
			Next
		Next
		screenunlock
		screensync
		sleep 32
	next
	need_redraw=0
End Sub
sub draw_screen(scale as uinteger=1)
	dim as ubyte ptr chars=screens_chars_addr(current_game_screen_nr)
	dim as ubyte ptr colors=screens_color_addr(current_game_screen_nr)
	for x as integer=0 to 40' step -1
		for y as integer=0 to 25' step -1
			dim col_pos as uinteger=y*20+(x\2)
			dim col as ubyte=iif(x mod 2=0,colors[col_pos] shr 4,colors[col_pos])
			draw_char(chars[y*40+x],x,y,col,scale)
		Next
	Next
End Sub
sub draw_to_screen(x_pos as uinteger,y_pos as uinteger,x_size as uinteger,y_size as uinteger,chars as ubyte ptr,colors as ubyte ptr,scale as uinteger=1)
	for x as integer=0 to x_size-1' step -1
		for y as integer=0 to y_size' step -1
			dim col_pos as uinteger=y*((x_size+1)\2)+(x\2)
			dim col as ubyte=iif(x mod 2=0,colors[col_pos] shr 4,colors[col_pos])
			draw_char(chars[y*(x_size)+x],x+x_pos,y+y_pos,col,scale)
		Next
	Next
End Sub
sub draw_char(char as ubyte,x as uinteger,y as uinteger,col as ubyte,scale as uinteger=1)
	col=col and &h0f
	for i as uinteger=0 to 7
		'if i mod 2=0 then
		for j as uinteger=0 to 7
			dim c as ubyte=((charset(char*8+i)shl j) and &h80)
			if c=&h80 then
				line(x*8*scale+j*scale,y*8*scale+i*scale)-(x*8*scale+j*scale+scale-1,y*8*scale+scale*i+scale-1),rgb(VIC_PALETTE(col*3+0),VIC_PALETTE(col*3+1),VIC_PALETTE(col*3+2)),BF
			else
				line(x*8*scale+j*scale,y*8*scale+i*scale)-(x*8*scale+j*scale+scale-1,y*8*scale+scale*i+scale-1),rgb(0,0,0),BF
			endif
			'endif
		next
	Next
End Sub
sub print_menue_color_cycle(scale as uinteger=1)
	draw_char(CURSOR_CODE,menu_cursor_addr(menu_cursor_select,0),menu_cursor_addr(menu_cursor_select,1),menu_cursor_color_cycle(0),scale)
End Sub
sub print_game_cursor_color_cycle(scale as uinteger=1)
	if selected_goblin(current_player)<>255 then
		draw_char(81,player_pos_x(current_player*4+animate_players,selected_goblin(current_player))*2+15,player_pos_y(current_player*4+animate_players,selected_goblin(current_player))*2+8,game_cursor_selected_goblin(0),scale)
	EndIf
	if (is_over_goblin(0)=255) and (is_over_goblin(1)=255) then
		draw_char(CURSOR_CODE,cursor_x_pos(current_player)*2+15,cursor_y_pos(current_player)*2+8,game_cursor_color_cycle(0),scale)
	endif
	if (is_over_goblin(0)<>255) and (is_over_goblin(1)=255) then
		draw_char(game_cursor_over_goblin_chars(0),cursor_x_pos(current_player)*2+15,cursor_y_pos(current_player)*2+8,game_cursor_over_goblin_red(0),scale)
	endif
	if (is_over_goblin(0)=255) and (is_over_goblin(1)<>255) then
		draw_char(game_cursor_over_goblin_chars(0),cursor_x_pos(current_player)*2+15,cursor_y_pos(current_player)*2+8,game_cursor_over_goblin_blue(0),scale)
	endif
End Sub
sub print_game_mode_str(scale as uinteger=1)
	draw_char(game_mode_string(game_mode,0),25+0,9,15,scale)
	draw_char(game_mode_string(game_mode,1),25+1,9,15,scale)
	draw_char(game_mode_string(game_mode,2),25+2,9,15,scale)
End Sub
sub print_sound_mode_str(scale as uinteger=1)
	draw_char(sound_mode_string(sound_mode,0),4,22,15,scale)
	draw_char(sound_mode_string(sound_mode,1),5,22,15,scale)
	draw_char(sound_mode_string(sound_mode,2),6,22,15,scale)
	draw_char(sound_mode_string(sound_mode,3),7,22,15,scale)
	draw_char(sound_mode_string(sound_mode,4),8,22,15,scale)
End Sub
sub print_help_screen_color_cycle(scale as uinteger=1)
	draw_char(188,1,11,help_screen_color_cycle_left(0),scale)
	draw_char(188,2,11,help_screen_color_cycle_left(1),scale)
	draw_char(188,3,11,help_screen_color_cycle_left(2),scale)
	draw_char(188,4,11,help_screen_color_cycle_left(3),scale)

	draw_char(190,34,11,help_screen_color_cycle_right(0),scale)
	draw_char(190,35,11,help_screen_color_cycle_right(1),scale)
	draw_char(190,36,11,help_screen_color_cycle_right(2),scale)
	draw_char(190,37,11,help_screen_color_cycle_right(3),scale)
End Sub
sub print_players(scale as uinteger=1)
	for i as uinteger=0 to 1
		for j as uinteger=0 to 6
			draw_char(81,player_pos_x(i*4+animate_players,j)*2+15,player_pos_y(i*4+animate_players,j)*2+8,player_colors(i),scale)
		Next
	next
End Sub

sub create_color_cycles()
	dim tmp as ubyte
	for i as uinteger=0 to 4
		tmp = credits_screen_color_cycle(i,0)
		for j as uinteger=0 to 5
			credits_screen_color_cycle(i,j)=credits_screen_color_cycle(i,j+1)
		Next
		credits_screen_color_cycle(i,2)=tmp
	Next

	tmp=menu_cursor_color_cycle(0)
	for i as uinteger=lbound(menu_cursor_color_cycle) to ubound(menu_cursor_color_cycle)-1
		menu_cursor_color_cycle(i)=menu_cursor_color_cycle(i+1)
	next
	menu_cursor_color_cycle(9)=tmp

	tmp=help_screen_color_cycle_left(0)
	for i as uinteger=lbound(help_screen_color_cycle_left) to ubound(help_screen_color_cycle_left)-1
		help_screen_color_cycle_left(i)=help_screen_color_cycle_left(i+1)
	next
	help_screen_color_cycle_left(11)=tmp

	tmp=help_screen_color_cycle_right(11)
	for i as integer=ubound(help_screen_color_cycle_right)-1 to lbound(help_screen_color_cycle_right) step -1
		help_screen_color_cycle_right(i+1)=help_screen_color_cycle_right(i)
	next
	help_screen_color_cycle_right(0)=tmp

	tmp=game_cursor_color_cycle(0)
	for i as uinteger=lbound(game_cursor_color_cycle) to ubound(game_cursor_color_cycle)-1
		game_cursor_color_cycle(i)=game_cursor_color_cycle(i+1)
	next
	game_cursor_color_cycle(9)=tmp

	tmp=game_cursor_over_goblin_chars(0)
	for i as uinteger=lbound(game_cursor_over_goblin_chars) to ubound(game_cursor_over_goblin_chars)-1
		game_cursor_over_goblin_chars(i)=game_cursor_over_goblin_chars(i+1)
	next
	game_cursor_over_goblin_chars(9)=tmp

	tmp=game_cursor_selected_goblin(0)
	for i as uinteger=lbound(game_cursor_selected_goblin) to ubound(game_cursor_selected_goblin)-1
		game_cursor_selected_goblin(i)=game_cursor_selected_goblin(i+1)
	next
	game_cursor_selected_goblin(9)=tmp

	tmp=game_cursor_over_goblin_blue(0)
	for i as uinteger=lbound(game_cursor_over_goblin_blue) to ubound(game_cursor_over_goblin_blue)-1
		game_cursor_over_goblin_blue(i)=game_cursor_over_goblin_blue(i+1)
	next
	game_cursor_over_goblin_blue(9)=tmp

	tmp=game_cursor_over_goblin_red(0)
	for i as uinteger=lbound(game_cursor_over_goblin_red) to ubound(game_cursor_over_goblin_red)-1
		game_cursor_over_goblin_red(i)=game_cursor_over_goblin_red(i+1)
	next
	game_cursor_over_goblin_red(9)=tmp

	if crystal_animator < 50 then
		tmp=current_player_color_cycle(current_player,0)
		for i as uinteger=0 to 3
			current_player_color_cycle(current_player,i)=current_player_color_cycle(current_player,i+1)
		next
		current_player_color_cycle(current_player,4)=tmp
	else
		crystal_animator = 50
	endif

end sub
sub print_credits_screen_color_cycle(scale as uinteger=1)
	draw_char(&hd1,13, 3,credits_screen_color_cycle(4,0),scale)
	draw_char(&hd1,25, 3,credits_screen_color_cycle(4,0),scale)
	draw_char(&hd1,17, 4,credits_screen_color_cycle(0,0),scale)
	draw_char(&hd1,21, 4,credits_screen_color_cycle(0,0),scale)
	draw_char(&hd1, 7, 8,credits_screen_color_cycle(1,0),scale)
	draw_char(&hd1,31, 8,credits_screen_color_cycle(1,0),scale)

	draw_char(&hd1,18, 6,credits_screen_color_cycle(3,0),scale)
	draw_char(&hd1,19, 6,credits_screen_color_cycle(2,0),scale)
	draw_char(&hd1,20, 6,credits_screen_color_cycle(3,0),scale)

	draw_char(&hd1,18,12,credits_screen_color_cycle(3,0),scale)
	draw_char(&hd1,19,12,credits_screen_color_cycle(2,0),scale)
	draw_char(&hd1,20,12,credits_screen_color_cycle(3,0),scale)

	draw_char(&hd1,18,14,credits_screen_color_cycle(3,0),scale)
	draw_char(&hd1,19,14,credits_screen_color_cycle(2,0),scale)
	draw_char(&hd1,20,14,credits_screen_color_cycle(3,0),scale)

	draw_char(&hd1,19, 8,credits_screen_color_cycle(2,0),scale)
	draw_char(&hd1,19,10,credits_screen_color_cycle(2,0),scale)
	draw_char(&hd1,19,16,credits_screen_color_cycle(2,0),scale)
End Sub

sub check_is_valid(x as byte, y as byte)
	is_valid=255
	dim as byte dist_x
	dim as byte dist_y
	if current_player=0 then
		dist_x=player_pos_x(current_player*4,selected_goblin(current_player))-x
		dist_y=player_pos_y(current_player*4,selected_goblin(current_player))-y
	else
		dist_x=player_pos_x(current_player*4+2,selected_goblin(current_player))-x
		dist_y=player_pos_y(current_player*4+2,selected_goblin(current_player))-y
	endif
	if (dist_x<-1) or (dist_x>1) and (dist_y<-1) or (dist_y>1) then
		is_valid=0
	EndIf
	if (dist_x=0) or (dist_y=0) then
		is_valid=0
	endif
	if (is_over_goblin(0)<>255) or (is_over_goblin(1) <>255) then
		is_valid=0
	EndIf
	if (x<0) or (y<0) then is_valid=0
	if (x>4) or (y>4) then is_valid=0
End Sub
sub check_is_over_goblin(x as byte,y as byte)
	is_over_goblin(0)=255
	is_over_goblin(1)=255
	is_over_any_goblin=255

	for i as uinteger=0 to 1
		for j as uinteger=0 to 6
			if (x=player_pos_x(i*4+animate_players,j) ) and (y=player_pos_y(i*4+animate_players,j)) then
				if i=0 then
					is_over_goblin(0)=j
				else
					is_over_goblin(1)=j
				endif
				is_over_any_goblin=j
			EndIf
		Next
	next
End Sub
sub update_player_pos()
	if current_player=0 then
		'0 grad
		player_pos_x(current_player*4+0,selected_goblin(current_player))=cursor_x_pos(current_player)
		player_pos_y(current_player*4+0,selected_goblin(current_player))=cursor_y_pos(current_player)

		'90 grad
		player_pos_x(current_player*4+1,selected_goblin(current_player))=4-cursor_y_pos(current_player)
		player_pos_y(current_player*4+1,selected_goblin(current_player))=cursor_x_pos(current_player)

		'180 grad
		player_pos_x(current_player*4+2,selected_goblin(current_player))=4-cursor_x_pos(current_player)
		player_pos_y(current_player*4+2,selected_goblin(current_player))=4-cursor_y_pos(current_player)

		'270 grad
		player_pos_x(current_player*4+3,selected_goblin(current_player))=cursor_y_pos(current_player)
		player_pos_y(current_player*4+3,selected_goblin(current_player))=4-cursor_x_pos(current_player)
	else
		'0 grad
		player_pos_x(current_player*4+2,selected_goblin(current_player))=cursor_x_pos(current_player)
		player_pos_y(current_player*4+2,selected_goblin(current_player))=cursor_y_pos(current_player)

		'90 grad
		player_pos_x(current_player*4+3,selected_goblin(current_player))=4-cursor_y_pos(current_player)
		player_pos_y(current_player*4+3,selected_goblin(current_player))=cursor_x_pos(current_player)

		'180 grad
		player_pos_x(current_player*4+0,selected_goblin(current_player))=4-cursor_x_pos(current_player)
		player_pos_y(current_player*4+0,selected_goblin(current_player))=4-cursor_y_pos(current_player)

		'270 grad
		player_pos_x(current_player*4+1,selected_goblin(current_player))=cursor_y_pos(current_player)
		player_pos_y(current_player*4+1,selected_goblin(current_player))=4-cursor_x_pos(current_player)
	endif
End Sub
sub reset_play_ground()
	for j as uinteger=0 to 7
		for i as uinteger=0 to 6
			player_pos_x(j,i)=player_start_pos_x(j,i)
			player_pos_y(j,i)=player_start_pos_y(j,i)
		Next
	next
	is_in_give_up=0
	is_over_goblin(0)=255
	is_over_goblin(1)=255
	selected_goblin(0)=255
	selected_goblin(1)=255
	cursor_x_pos(0)=2
	cursor_x_pos(1)=2
	cursor_y_pos(0)=2
	cursor_y_pos(1)=2
	current_player=0
	animate_players=0
	animate_flag=0
	new_game=0
	yes_no=0
	win=0
	credits_counter=0
End Sub
sub check_for_win()
	if current_game_screen_nr=1 then
		win=0
		for j as uinteger=0 to 6
			for i as uinteger=0 to 6
				if (player_pos_x(current_player*4,i)=player_win_pos_x(current_player,j)) and (player_pos_y(current_player*4,i)=player_win_pos_y(current_player,j)) then
					win+=1
				EndIf
			Next
		next
	endif
	if win=7 then
		reset_play_ground()
		need_redraw=1
		last_game_screen_nr=current_game_screen_nr
		current_game_screen_nr=5
	EndIf
End Sub
sub ki_thinking(player as ubyte)
	'dim as ubyte t_select=	selected_goblin(current_player)

	for i as uinteger=0 to 6
		ki_gnome_score(current_player,i)=0
		for j as uinteger=0 to 3
			ki_gnome_move_score(current_player,i,j)=0
		next
	next

	for i as uinteger=0 to 6
		'selected_goblin(current_player)=i
		for j as uinteger=0 to 3
			dim as byte t_x_pos = player_pos_x(current_player*4+animate_players,i)
			dim as byte t_y_pos = player_pos_y(current_player*4+animate_players,i)
			dim as byte t0_x_pos
			dim as byte t0_y_pos
			t_x_pos+=ki_cursor_moves(j,0)
			t_y_pos+=ki_cursor_moves(j,1)
			if t_x_pos<0 then continue for
			if t_x_pos>4 then continue for
			if t_y_pos<0 then continue for
			if t_y_pos>4 then continue for


			check_is_over_goblin(t_x_pos,t_y_pos)

			if is_over_any_goblin=255 then
				if j=0 or j=2 then
					ki_gnome_move_score(current_player,i,j)+=2
				else
					ki_gnome_move_score(current_player,i,j)+=1
				endif
			else
				ki_gnome_move_score(current_player,i,j)-=3
			EndIf

			for k as uinteger=0 to 3
				t0_x_pos=t_x_pos+ki_cursor_moves(k,0)
				t0_y_pos=t_y_pos+ki_cursor_moves(k,1)
				if t0_x_pos<0 then continue for
				if t0_x_pos>4 then continue for
				if t0_y_pos<0 then continue for
				if t0_y_pos>4 then continue for

				check_is_over_goblin(t0_x_pos,t0_y_pos)
				if (is_over_goblin(current_player)=255) and (is_over_goblin((current_player+1) and 1)<>255)  then
					ki_gnome_move_score(current_player,i,j)+=2
				else
					ki_gnome_move_score(current_player,i,j)+=1
				EndIf
			next
		next
	next

	for i as uinteger=0 to 6
		for j as uinteger=0 to 3
			ki_gnome_score(current_player,i)+=ki_gnome_move_score(current_player,i,j)
		next
	next

	'selected_goblin(current_player)=t_select

	if selected_goblin(current_player)=ki_last_gnome(current_player) then
		ki_gnome_score(current_player,ki_last_gnome(current_player))-=ki_last_gnome_round(current_player)*10
	else
		ki_last_gnome_round(current_player)=0
	endif
	'print ki_last_gnome(0),ki_last_gnome_round(current_player)

	dim s as ubyte=0
	dim max as double=-999999999
	dim k as ubyte
	dim max0 as double = -99999999
	for i as uinteger = 0 to 6
		if max<ki_gnome_score(current_player,i) then
			max=ki_gnome_score(current_player,i)
			s=i
			k=0
			max0=-99999999
			for j as uinteger=0 to 3
				if max0< ki_gnome_move_score(current_player,i,j) then
					max0=ki_gnome_move_score(current_player,i,j)
					k=j
				EndIf
			Next
		EndIf
	next


	dim dist_x as byte
	dim dist_y as byte
	if selected_goblin(current_player)<>255 then
		if current_player=0 then
			dist_x=player_pos_x(current_player*4,selected_goblin(current_player))-cursor_x_pos(current_player)+ki_cursor_moves(k,0)
			dist_y=player_pos_y(current_player*4,selected_goblin(current_player))-cursor_y_pos(current_player)+ki_cursor_moves(k,1)
		else
			dist_x=player_pos_x(current_player*4+2,selected_goblin(current_player))-cursor_x_pos(current_player)+ki_cursor_moves(k,0)
			dist_y=player_pos_y(current_player*4+2,selected_goblin(current_player))-cursor_y_pos(current_player)+ki_cursor_moves(k,1)
		endif
	else
		if current_player=0 then
			dist_x=player_pos_x(current_player*4,s)-cursor_x_pos(current_player)
			dist_y=player_pos_y(current_player*4,s)-cursor_y_pos(current_player)
		else
			dist_x=player_pos_x(current_player*4+2,s)-cursor_x_pos(current_player)
			dist_y=player_pos_y(current_player*4+2,s)-cursor_y_pos(current_player)
		endif
	endif

	'draw_char(dist_x+48,15,0,15,3)
	'draw_char(dist_y+48,17,0,15,3)
	'draw_char(s+48,19,0,15,3)
	'draw_char(k+48,21,0,15,3)
	if (skipper_count and 7)=0 then
		if ((dist_x = 0) and (dist_y=0)) then
			'if ki_round=1 then
			'	ki_last_gnome(current_player)=s
			'	ki_last_gnome_move(current_player)=k
			'endif
			check_is_over_goblin(cursor_x_pos(current_player),cursor_y_pos(current_player))
			check_is_valid(cursor_x_pos(current_player),cursor_y_pos(current_player))
			game_joy_fire_fn()
			exit sub
		EndIf
		if dist_x < 0 then
			game_joy_left_fn()
			exit sub
		EndIf
		if dist_x > 0 then
			game_joy_right_fn()
		EndIf
		if dist_y < 0 then
			game_joy_up_fn()
			exit sub
		EndIf
		if dist_y > 0 then
			game_joy_down_fn()
			exit sub
		EndIf
	endif

End sub
